﻿using ContextLib;
using Entities;
using Microsoft.Extensions.DependencyModel;
using System.Diagnostics;
using StubbedContextLib;
/*
namespace App
{
    class Program
    {
        static void Main(string[] args)
        {
            BookEntity book2 = new BookEntity
            {
                Id = 2,
                Author = "Vianney",
                Title = "Gros",
                Isbn = "0015150"
            };

            BookEntity book3 = new BookEntity
            {
                Id = 3,
                Author = "Khéna",
                Title = "Khéna. Un homme, un livre",
                Isbn = "666666b"
            };

            using (var context = new LibraryContext())
            {
                Console.WriteLine("insertion");
                context.Add(book2);
                context.Add(book3);
                context.SaveChanges();
            }

            using (var context = new LibraryContext())
            {
                foreach (var n in context.BooksSet)
                {
                    Console.WriteLine($"{n.Id} - {n.Author}");
                }
                context.SaveChanges();
            }
        }
    }
}*/


List<BookEntity> books = new List<BookEntity>();
StubContext myStub = new StubContext();

// Insertion de livres dans la base de données
using (var context = new LibraryContext())
{
    Console.WriteLine("Insertion\n");

    books = await myStub.booksStub();

    // Ajoute chaque livre à la base de données de manière asynchrone
    foreach (var book in books)
    {
        await context.BooksSet.AddAsync(book);
    }

    // Enregistre les modifications dans la base de données
    await context.SaveChangesAsync();
}

// Récupération et affichage des livres de la base de données
using (var context = new LibraryContext())
{
    Console.WriteLine("Récupération\n");

    foreach (var book in context.BooksSet)
    {
        Console.WriteLine($"{book.Title}, Auteur : {book.Author}");
    }
}

// Suppression d'un livre avec l'ID 2 de la base de données
using (var context = new LibraryContext())
{
    Console.WriteLine("Suppression\n");

    var book = context.BooksSet.FirstOrDefault(b => b.Id == 2);
    if (book != null)
    {
        context.BooksSet.Remove(book);
        await context.SaveChangesAsync();
    }
}

// Modification du titre d'un livre avec l'auteur "Martin"
using (var context = new LibraryContext())
{
    Console.WriteLine("Modification\n");

    var bookToUpdate = context.BooksSet.FirstOrDefault(b => b.Author == "Martin");
    if (bookToUpdate != null)
    {
        bookToUpdate.Title = "Soir";
        await context.SaveChangesAsync();
    }
}